------------------
--Config
local t = .5		-- fade time in seconds
------------------

local hcic = CreateFrame('Frame')
local frames = {GeneralDockManager, ChatFrameMenuButton}
--Events
local event = CreateFrame('Frame')
event:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
--Register events
event:RegisterEvent('PLAYER_REGEN_ENABLED')
event:RegisterEvent('PLAYER_REGEN_DISABLED')
event:RegisterEvent('PLAYER_LOGIN')
event:RegisterEvent('PET_BATTLE_CLOSE')
event:RegisterEvent('PET_BATTLE_OPENING_START')
--Handle events
function event:PLAYER_REGEN_ENABLED()
    hcic:fade(0)
end
function event:PLAYER_REGEN_DISABLED()
   hcic:fade(1)
end
function event:PLAYER_LOGIN()
	if QuickJoinToastButton:IsShown() then
		frames[3] = QuickJoinToastButton
	end
end
function event:PET_BATTLE_CLOSE()
	hcic:fade(0)
end
function event:PET_BATTLE_OPENING_START()
	hcic:fade(1)
end

--Fade
--0: fade in, 1: fade out
function hcic:fade(mode)
	frames["SELECTED_CHAT_FRAME"] = SELECTED_CHAT_FRAME
	for _, frame in pairs(frames) do
		local alpha = frame:GetAlpha()
		--fade in
		if mode == 0 then
			frame.Show = Show
			frame:Show()
			UIFrameFadeIn(frame, t*(1-alpha), alpha, 1)
		--fade out
		else
			UIFrameFadeOut(frame, t*alpha, alpha, 0)
			frame.Show = function() end
			frame.fadeInfo.finishedArg1 = frame
			frame.fadeInfo.finishedFunc = frame.Hide
		end
	end	
end
--ChatMouseover
function hcic:ChatOnLeave ()
	local f = GetMouseFocus()
	if f then
		if f:GetName() == "QuickJoinToastButton" or f:GetName() == "ChatFrameMenuButton" then
			return nil
		end
		if f:GetName() == SELECTED_CHAT_FRAME:GetName().."ButtonFrameBottomButton" then
			return nil
		end
		if f:GetParent() then
			f = f:GetParent()
			if f:GetName() == SELECTED_CHAT_FRAME:GetName() or f:GetName() == "GeneralDockManager" then
				return nil
			end
			if f:GetParent() then
				if f:GetParent():GetName() == "GeneralDockManagerScrollFrame" then
					return nil
				end
			end
		end
	end
	UIFrameFadeOut(chatMouseover, .5, chatMouseover:GetAlpha(), 0)
	if UnitAffectingCombat("player") or C_PetBattles.IsInBattle() then
		hcic:fade(1)
	end
end

local chatMouseover = CreateFrame("Frame", "chatMouseover")
chatMouseover:SetPoint("BOTTOMLEFT", "ChatFrame1", "BOTTOMLEFT", -20, -10)
chatMouseover:SetPoint("TOPRIGHT", "ChatFrame1", "TOPRIGHT", 10, 10)
chatMouseover:SetScript("OnEnter", function()
	if UnitAffectingCombat("player") or C_PetBattles.IsInBattle() then
		hcic:fade(0)
	end
	end)
chatMouseover:SetScript("OnLeave", function() hcic:ChatOnLeave() end)
chatMouseover:SetFrameStrata("BACKGROUND")

WorldFrame:HookScript("OnEnter", function()	hcic:ChatOnLeave() end)
